SystemOrganization addCategory: #MonticelloXml!
SystemOrganization addCategory: #'MonticelloXml-Test'!

MCMczReader subclass: #MCXmlReader
	instanceVariableNames: 'objects version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlReader class methodsFor: 'accessing' stamp: 'rt 11/14/2007 12:56'!
extension
	^ 'xml'! !

!MCXmlReader methodsFor: 'loading' stamp: 'rt 11/19/2007 02:35'!
loadDefinitions
	definitions := version snapshot definitions.! !

!MCXmlReader methodsFor: 'loading' stamp: 'rt 11/19/2007 02:35'!
loadDependencies
	dependencies := version dependencies! !

!MCXmlReader methodsFor: 'loading' stamp: 'rt 11/19/2007 02:35'!
loadPackage
	package := version package.! !

!MCXmlReader methodsFor: 'loading' stamp: 'rt 11/19/2007 02:35'!
loadVersionInfo
	info := version info.! !

!MCXmlReader methodsFor: 'accessing' stamp: 'rt 11/19/2007 02:36'!
stream: aStream
	stream := (SixxReadStream on: aStream).
	version := stream contents first.! !

MCWorkingCopy subclass: #MCXmlWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlWorkingCopy class methodsFor: 'converting' stamp: 'cop 11/21/2007 21:13'!
from: aWC
	| inst |
	inst := ( self new) package: aWC package;
				modified: aWC modified;
				ancestry: aWC ancestry;
				repositoryGroup: aWC repositoryGroup.
	aWC requiredPackages do: [ :each | inst requirePackage: each ].
	^inst.
			! !

!MCXmlWorkingCopy methodsFor: 'accessing' stamp: 'cop 11/21/2007 21:15'!
ancestry: aMCWorkingAncestry 
	ancestry := aMCWorkingAncestry.! !

!MCXmlWorkingCopy methodsFor: 'as yet unclassified' stamp: 'cop 11/21/2007 20:43'!
newVersionWithName: nameString message: messageString
	| info deps |
	info := ancestry infoWithName: nameString message: messageString.
	ancestry := MCWorkingAncestry new addAncestor: info.
	self modified: true; modified: false.
	
	deps := self requiredPackages collect:
		[:ea | 
		MCVersionDependency
			package: ea
			info: ea workingCopy currentVersionInfo].

	^ MCXmlVersion
		package: package
		info: info
		snapshot: package snapshot
		dependencies: deps! !

!MCXmlWorkingCopy methodsFor: 'accessing' stamp: 'cop 11/21/2007 21:14'!
package: aMCPackage 
	package := aMCPackage.! !

MCWriter subclass: #MCXmlWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlWriter class methodsFor: 'writing' stamp: 'rt 11/14/2007 12:50'!
fileOut: aVersion on: aStream
	| inst |
	inst := self on: (SixxWriteStream on: aStream).
	inst writeVersion: aVersion.
	inst close.
! !

!MCXmlWriter class methodsFor: 'accessing' stamp: 'rt 11/14/2007 12:30'!
readerClass
	^MCXmlReader! !

!MCXmlWriter methodsFor: 'closing' stamp: 'rt 11/14/2007 12:26'!
close
	stream close! !

!MCXmlWriter methodsFor: 'writing' stamp: 'rt 11/19/2007 02:36'!
writeVersion: aVersion
	stream nextPut: aVersion.! !

MCVersion subclass: #MCXmlVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlVersion class methodsFor: 'converting' stamp: 'rt 11/15/2007 22:19'!
fromVersion: aVersion
	^(self new)
		package: aVersion package;
		info: aVersion info;
		snapshot: aVersion snapshot;
		dependencies: aVersion dependencies.! !

!MCXmlVersion methodsFor: 'private-converting' stamp: 'rt 11/15/2007 22:15'!
dependencies: aDependencies
	dependencies := aDependencies! !

!MCXmlVersion methodsFor: 'private-converting' stamp: 'rt 11/15/2007 22:14'!
info: aInfo
	info := aInfo! !

!MCXmlVersion methodsFor: 'private-converting' stamp: 'rt 11/15/2007 22:13'!
package: aPackage
	package := aPackage! !

!MCXmlVersion methodsFor: 'private-converting' stamp: 'rt 11/15/2007 22:15'!
snapshot: aSnapshot
	snapshot := aSnapshot! !

!MCXmlVersion methodsFor: 'accessing' stamp: 'rt 11/15/2007 20:29'!
writerClass
	^ MCXmlWriter ! !

MCWorkingCopyBrowser subclass: #MCXmlWorkingCopyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlWorkingCopyBrowser methodsFor: 'setting' stamp: 'rt 11/16/2007 01:11'!
askTheUserForTheFormat
	^TCToolForXmlFormatRequest new showModally! !

!MCXmlWorkingCopyBrowser methodsFor: 'setting' stamp: 'rt 11/19/2007 02:26'!
chooseFormat
	^ self askTheUserForTheFormat! !

!MCXmlWorkingCopyBrowser methodsFor: 'saving' stamp: 'cop 11/21/2007 20:50'!
saveInXml
	| repo |	
	self canSave ifFalse: [^self].
	self checkForNewerVersions ifFalse: [^self].
	repo _ self repository.
	workingCopy newVersion ifNotNilDo:
		[:aVersion |
		|v|
		v := MCXmlVersion fromVersion: aVersion.
		(MCVersionInspector new version: v) show.
		Cursor wait showWhile: [repo storeVersion: v].
		MCCacheRepository default cacheAllFileNamesDuring: 
			[repo cacheAllFileNamesDuring: 
				[v allAvailableDependenciesDo:
					[:dep |
					(repo includesVersionNamed: dep info name)
						ifFalse: [repo storeVersion: dep]]]]]! !

!MCXmlWorkingCopyBrowser methodsFor: 'saving' stamp: 'rt 11/19/2007 02:38'!
saveVersion
	| answer |
	answer := self chooseFormat.
	answer ifNil: [^nil].
	answer = #xml ifTrue: [^self saveInXml].
	^super saveVersion! !

!MCXmlWorkingCopyBrowser methodsFor: 'setting' stamp: 'cop 11/21/2007 20:53'!
workingCopy: wc
	workingCopy := MCXmlWorkingCopy from: wc.
	self changed: #workingCopyList; changed: #workingCopySelection; changed: #repositoryList.
	self changedButtons.! !

MCTool subclass: #TCToolForXmlFormatRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/19/2007 03:04'!
buttonSpecs
	^ #((Xml chooseXml 'choode xml for the package')
		(Mcz chooseMcz 'choose mcz for the package')
		(Cancel cancel 'cancel saving version')
		) ! !

!TCToolForXmlFormatRequest methodsFor: 'answering' stamp: 'rt 11/16/2007 00:41'!
cancel
	self answer: nil! !

!TCToolForXmlFormatRequest methodsFor: 'answering' stamp: 'rt 11/16/2007 00:41'!
chooseMcz
	self answer: #mcz! !

!TCToolForXmlFormatRequest methodsFor: 'answering' stamp: 'rt 11/16/2007 00:41'!
chooseXml
	self answer: #xml! !

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/16/2007 01:16'!
defaultExtent 
	^ 300@100! !

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/16/2007 00:49'!
defaultLabel
	^'Format Request'! !

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/19/2007 03:03'!
request
	^ 'Please choose a format for the package.'! !

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/16/2007 01:17'!
showModally
	modal := true.
	self window openInWorldExtent: self defaultExtent.
	[self window world notNil] whileTrue: [
		self window outermostWorldMorph doOneCycle.
	].
	morph := nil.
	^ modalValue! !

!TCToolForXmlFormatRequest methodsFor: 'morphic ui' stamp: 'rt 11/19/2007 03:03'!
widgetSpecs
	^ #(	
		((textMorph: request) (0 0 1 0) (0 0 0 30))
		((buttonRow) (0 1 1 1) (0 -30 0 0))
		)! !

TestCase subclass: #MCXmlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml-Test'!

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 16:27'!
assertVersion: version isEqualVersion: version2 

	self assert: version package = version2 package.
	self assert: version info = version2 info.
	self assert: version snapshot = version2 snapshot.
	self assert: version dependencies = version2 dependencies.! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'cop 11/21/2007 20:18'!
createVersion
	^ MCXmlVersion 
		package: (MCPackage named: 'testPack')
		info: self createVersionInfo
		snapshot: MCSnapshot empty
		dependencies: { }! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 16:45'!
createVersionInfo
	^ MCVersionInfo name: 'Test-rt0.1' id: 'testID20071114' message: 'first-test-version' date: '14 November 2007' time: '16:45:00' author: 'authorRt' ancestors: '#()'! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 17:13'!
testContent
	| stream version xmlReader |
	version := self createVersion.
	stream := RWBinaryOrTextStream on: ''.
	MCXmlWriter fileOut: version on: stream.
	stream reset.
	xmlReader := MCXmlReader on: stream.
	stream close.
	self assertVersion: version isEqualVersion: xmlReader version! !
